i18n: make GETTEXT_POISON a runtime option
[git/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
3c8f12c9
JH
18# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
85176d72
FC
26else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
30fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
d0cc5796
JK
39# If we were built with ASAN, it may complain about leaks
40# of program-lifetime variables. Disable it by default to lower
41# the noise level. This needs to happen at the start of the script,
42# before we even do our "did we build git yet" check (since we don't
43# want that one to complain to stderr).
bf1ce904 44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
d0cc5796
JK
45export ASAN_OPTIONS
46
85b81b35
JK
47# If LSAN is in effect we _do_ want leak checking, but we still
48# want to abort so that we notice the problems.
49: ${LSAN_OPTIONS=abort_on_error=1}
50export LSAN_OPTIONS
51
2006f0ad
RR
52################################################################
53# It appears that people try to run tests without building...
54"$GIT_BUILD_DIR/git" >/dev/null
55if test $? != 1
56then
57 echo >&2 'error: you do not seem to have built git yet.'
58 exit 1
59fi
60
3c8f12c9
JH
61. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
62export PERL_PATH SHELL_PATH
63
4cde519f
RR
64# if --tee was passed, write the output not only to the terminal, but
65# additionally to the file test-results/$BASENAME.out, too.
66case "$GIT_TEST_TEE_STARTED, $* " in
67done,*)
68 # do not redirect again
69 ;;
452320f1 70*' --tee '*|*' --va'*|*' --verbose-log '*)
2d14e13c
JK
71 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
72 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
452320f1
JK
73
74 # Make this filename available to the sub-process in case it is using
75 # --verbose-log.
76 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
77 export GIT_TEST_TEE_OUTPUT_FILE
78
79 # Truncate before calling "tee -a" to get rid of the results
80 # from any previous runs.
81 >"$GIT_TEST_TEE_OUTPUT_FILE"
82
3f824e91 83 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
452320f1 84 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
925bdc92 85 test "$(cat "$BASE.exit")" = 0
4cde519f
RR
86 exit
87 ;;
88esac
89
e1970ce4 90# For repeatability, reset the environment to known value.
d5c1b7c2 91# TERM is sanitized below, after saving color control sequences.
e1970ce4 92LANG=C
899460f3 93LC_ALL=C
d9bdd39e 94PAGER=cat
e1970ce4 95TZ=UTC
d5c1b7c2 96export LANG LC_ALL PAGER TZ
8ff99e74 97EDITOR=:
6cdccfce
ÆAB
98
99# GIT_TEST_GETTEXT_POISON should not influence git commands executed
100# during initialization of test-lib and the test repo. Back it up,
101# unset and then restore after initialization is finished.
102if test -n "$GIT_TEST_GETTEXT_POISON"
103then
104 GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
105 unset GIT_TEST_GETTEXT_POISON
106fi
107
661bfd13
SL
108# A call to "unset" with no arguments causes at least Solaris 10
109# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
110# deriving from the command substitution clustered with the other
111# ones.
3c8f12c9 112unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 113 my @env = keys %ENV;
730477f1
JL
114 my $ok = join("|", qw(
115 TRACE
116 DEBUG
730477f1
JL
117 TEST
118 .*_TEST
119 PROVE
120 VALGRIND
ac001282 121 UNZIP
edb54081 122 PERF_
e2a0ccc0 123 CURL_VERBOSE
4527aa10 124 TRACE_CURL
730477f1
JL
125 ));
126 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
127 print join("\n", @vars);
128')
7976e901 129unset XDG_CACHE_HOME
5adf84eb 130unset XDG_CONFIG_HOME
8bade1e1 131unset GITPERLLIB
29e55cd5
JH
132GIT_AUTHOR_EMAIL=author@example.com
133GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
134GIT_COMMITTER_EMAIL=committer@example.com
135GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 136GIT_MERGE_VERBOSITY=5
f8246281
JH
137GIT_MERGE_AUTOEDIT=no
138export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
139export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
140export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 141export EDITOR
e1970ce4 142
124647c4
KB
143# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
144GIT_TRACE_BARE=1
145export GIT_TRACE_BARE
146
4cb54d0a 147check_var_migration () {
4231d1ba
JH
148 # the warnings and hints given from this helper depends
149 # on end-user settings, which will disrupt the self-test
150 # done on the test framework itself.
151 case "$GIT_TEST_FRAMEWORK_SELFTEST" in
152 t) return ;;
153 esac
154
4cb54d0a
BP
155 old_name=$1 new_name=$2
156 eval "old_isset=\${${old_name}:+isset}"
157 eval "new_isset=\${${new_name}:+isset}"
4231d1ba 158
4cb54d0a
BP
159 case "$old_isset,$new_isset" in
160 isset,)
161 echo >&2 "warning: $old_name is now $new_name"
162 echo >&2 "hint: set $new_name too during the transition period"
163 eval "$new_name=\$$old_name"
164 ;;
165 isset,isset)
166 # do this later
167 # echo >&2 "warning: $old_name is now $new_name"
168 # echo >&2 "hint: remove $old_name"
169 ;;
170 esac
171}
172
173check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
1f357b04 174check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
5765d97b 175check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
1f357b04
BP
176
177# Use specific version of the index file format
178if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
5d9fc888 179then
1f357b04 180 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
5d9fc888
TG
181 export GIT_INDEX_VERSION
182fi
183
a731fa91
EP
184# Add libc MALLOC and MALLOC_PERTURB test
185# only if we are not executing the test with valgrind
1b3185fc 186if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 187 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
188then
189 setup_malloc_check () {
190 : nothing
191 }
192 teardown_malloc_check () {
193 : nothing
194 }
195else
196 setup_malloc_check () {
197 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
198 export MALLOC_CHECK_ MALLOC_PERTURB_
199 }
200 teardown_malloc_check () {
201 unset MALLOC_CHECK_ MALLOC_PERTURB_
202 }
203fi
a731fa91 204
886a3907
JH
205# Protect ourselves from common misconfiguration to export
206# CDPATH into the environment
207unset CDPATH
208
5565f47c 209unset GREP_OPTIONS
ac001282 210unset UNZIP
5565f47c 211
3d5c0cc9 212case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756 2131|2|true)
025232e8 214 GIT_TRACE=4
1c0cc756 215 ;;
6ce4e61f
CC
216esac
217
cd3c095c
JH
218# Convenience
219#
5555a2aa 220# A regexp to match 5, 35 and 40 hexdigits
cd3c095c 221_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
5555a2aa
CB
222_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
223_x40="$_x35$_x05"
cd3c095c 224
3749fde5
JH
225# Zero SHA-1
226_z40=0000000000000000000000000000000000000000
227
bd981d5f 228OID_REGEX="$_x40"
198857bf 229ZERO_OID=$_z40
f9e7d9f8 230EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
378932d3 231EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
f9e7d9f8 232
3f4ab627
JH
233# Line feed
234LF='
235'
236
a42643aa
JK
237# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
238# when case-folding filenames
239u200c=$(printf '\342\200\214')
240
bd981d5f 241export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
342e9ef2 242
e1970ce4
JH
243# Each test should start with something like this, after copyright notices:
244#
245# test_description='Description of this test...
246# This test checks if command xyzzy does the right thing...
247# '
248# . ./test-lib.sh
d5c1b7c2 249test "x$TERM" != "xdumb" && (
ca92a660
RH
250 test -t 1 &&
251 tput bold >/dev/null 2>&1 &&
252 tput setaf 1 >/dev/null 2>&1 &&
253 tput sgr0 >/dev/null 2>&1
254 ) &&
255 color=t
e1970ce4 256
e1970ce4
JH
257while test "$#" -ne 0
258do
259 case "$1" in
260 -d|--d|--de|--deb|--debu|--debug)
261 debug=t; shift ;;
886856ab
JH
262 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
263 immediate=t; shift ;;
5e2c08c6 264 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 265 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
0445e6f0
IB
266 -r)
267 shift; test "$#" -ne 0 || {
268 echo 'error: -r requires an argument' >&2;
269 exit 1;
270 }
271 run_list=$1; shift ;;
272 --run=*)
0ff74101 273 run_list=${1#--*=}; shift ;;
e1970ce4 274 -h|--h|--he|--hel|--help)
570f3226 275 help=t; shift ;;
e1970ce4
JH
276 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
277 verbose=t; shift ;;
ff09af3f 278 --verbose-only=*)
0ff74101 279 verbose_only=${1#--*=}
ff09af3f 280 shift ;;
1ece1274 281 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
282 # Ignore --quiet under a TAP::Harness. Saying how many tests
283 # passed without the ok/not ok details is always an error.
284 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
285 --with-dashes)
286 with_dashes=t; shift ;;
55db1df0 287 --no-color)
faa4bc35 288 color=; shift ;;
4e1be63c 289 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
290 valgrind=memcheck
291 shift ;;
292 --valgrind=*)
0ff74101 293 valgrind=${1#--*=}
952af351 294 shift ;;
5dfc368f 295 --valgrind-only=*)
0ff74101 296 valgrind_only=${1#--*=}
5dfc368f 297 shift ;;
44138559
JS
298 --tee)
299 shift ;; # was handled already
f423ef5f 300 --root=*)
0ff74101 301 root=${1#--*=}
f423ef5f 302 shift ;;
bb79af9d
JK
303 --chain-lint)
304 GIT_TEST_CHAIN_LINT=1
305 shift ;;
306 --no-chain-lint)
307 GIT_TEST_CHAIN_LINT=0
308 shift ;;
a136f6d8 309 -x)
5fc98e79
SG
310 # Some test scripts can't be reliably traced with '-x',
311 # unless the test is run with a Bash version supporting
312 # BASH_XTRACEFD (introduced in Bash v4.1). Check whether
313 # this test is marked as such, and ignore '-x' if it
314 # isn't executed with a suitable Bash version.
315 if test -z "$test_untraceable" || {
316 test -n "$BASH_VERSION" && {
317 test ${BASH_VERSINFO[0]} -gt 4 || {
318 test ${BASH_VERSINFO[0]} -eq 4 &&
319 test ${BASH_VERSINFO[1]} -ge 1
320 }
321 }
322 }
323 then
324 trace=t
325 else
326 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
327 fi
a136f6d8 328 shift ;;
452320f1
JK
329 --verbose-log)
330 verbose_log=t
331 shift ;;
e1970ce4 332 *)
1f729dca 333 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
334 esac
335done
336
26a07309 337if test -n "$valgrind_only"
5dfc368f
TR
338then
339 test -z "$valgrind" && valgrind=memcheck
340 test -z "$verbose" && verbose_only="$valgrind_only"
341elif test -n "$valgrind"
342then
88c6e9d3 343 test -z "$verbose_log" && verbose=t
5dfc368f 344fi
952af351 345
f5ba2de6
JK
346if test -n "$trace" && test -z "$verbose_log"
347then
348 verbose=t
349fi
350
ca92a660
RH
351if test -n "$color"
352then
d5c1b7c2
RH
353 # Save the color control sequences now rather than run tput
354 # each time say_color() is called. This is done for two
355 # reasons:
356 # * TERM will be changed to dumb
357 # * HOME will be changed to a temporary directory and tput
358 # might need to read ~/.terminfo from the original HOME
359 # directory to get the control sequences
360 # Note: This approach assumes the control sequences don't end
361 # in a newline for any terminal of interest (command
362 # substitutions strip trailing newlines). Given that most
363 # (all?) terminals in common use are related to ECMA-48, this
364 # shouldn't be a problem.
365 say_color_error=$(tput bold; tput setaf 1) # bold red
366 say_color_skip=$(tput setaf 4) # blue
367 say_color_warn=$(tput setaf 3) # brown/yellow
368 say_color_pass=$(tput setaf 2) # green
369 say_color_info=$(tput setaf 6) # cyan
370 say_color_reset=$(tput sgr0)
371 say_color_="" # no formatting for normal text
ca92a660 372 say_color () {
d5c1b7c2
RH
373 test -z "$1" && test -n "$quiet" && return
374 eval "say_color_color=\$say_color_$1"
ca92a660 375 shift
d5c1b7c2 376 printf "%s\\n" "$say_color_color$*$say_color_reset"
ca92a660
RH
377 }
378else
379 say_color() {
380 test -z "$1" && test -n "$quiet" && return
381 shift
382 printf "%s\n" "$*"
383 }
384fi
385
d5c1b7c2
RH
386TERM=dumb
387export TERM
388
55db1df0
PH
389error () {
390 say_color error "error: $*"
6e7b5aaf 391 GIT_EXIT_OK=t
55db1df0
PH
392 exit 1
393}
394
395say () {
396 say_color info "$*"
397}
398
614fe015
JK
399if test -n "$HARNESS_ACTIVE"
400then
401 if test "$verbose" = t || test -n "$verbose_only"
402 then
403 printf 'Bail out! %s\n' \
404 'verbose mode forbidden under TAP harness; try --verbose-log'
405 exit 1
406 fi
407fi
408
570f3226
MB
409test "${test_description}" != "" ||
410error "Test script did not set test_description."
411
412if test "$help" = "t"
413then
cb1aefda 414 printf '%s\n' "$test_description"
570f3226
MB
415 exit 0
416fi
417
4d9d62fa 418exec 5>&1
781f76b1 419exec 6<&0
4ecae3c8 420exec 7>&2
452320f1
JK
421if test "$verbose_log" = "t"
422then
423 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
424elif test "$verbose" = "t"
e1970ce4
JH
425then
426 exec 4>&2 3>&1
427else
428 exec 4>/dev/null 3>/dev/null
429fi
430
d88785e4
JK
431# Send any "-x" output directly to stderr to avoid polluting tests
432# which capture stderr. We can do this unconditionally since it
433# has no effect if tracing isn't turned on.
434#
435# Note that this sets up the trace fd as soon as we assign the variable, so it
436# must come after the creation of descriptor 4 above. Likewise, we must never
437# unset this, as it has the side effect of closing descriptor 4, which we
438# use to show verbose tests to the user.
439#
440# Note also that we don't need or want to export it. The tracing is local to
441# this shell, and we would not want to influence any shells we exec.
442BASH_XTRACEFD=4
443
e1970ce4
JH
444test_failure=0
445test_count=0
41ac414e
JH
446test_fixed=0
447test_broken=0
2d84e9fb 448test_success=0
e1970ce4 449
d998bd4a
ÆAB
450test_external_has_tap=0
451
faa4bc35 452die () {
6e7b5aaf
CB
453 code=$?
454 if test -n "$GIT_EXIT_OK"
455 then
456 exit $code
457 else
458 echo >&5 "FATAL: Unexpected exit with code $code"
459 exit 1
460 fi
faa4bc35
CB
461}
462
6e7b5aaf 463GIT_EXIT_OK=
35641310 464trap 'die' EXIT
da706545 465trap 'exit $?' INT
41184273 466
12a29b1a
TR
467# The user-facing functions are loaded from a separate file so that
468# test_perf subshells can have them too
3c8f12c9 469. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 470
886856ab 471# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 472# the test_expect_* functions instead.
886856ab
JH
473
474test_ok_ () {
d5d9de1b 475 test_success=$(($test_success + 1))
633fe50a 476 say_color "" "ok $test_count - $@"
e1970ce4
JH
477}
478
886856ab 479test_failure_ () {
d5d9de1b 480 test_failure=$(($test_failure + 1))
633fe50a 481 say_color error "not ok $test_count - $1"
bf0dd8a8 482 shift
cb1aefda 483 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 484 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
485}
486
41ac414e 487test_known_broken_ok_ () {
41ac414e 488 test_fixed=$(($test_fixed+1))
633fe50a 489 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
490}
491
492test_known_broken_failure_ () {
41ac414e 493 test_broken=$(($test_broken+1))
633fe50a 494 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 495}
886856ab
JH
496
497test_debug () {
8e832ebc 498 test "$debug" = "" || eval "$1"
e1970ce4
JH
499}
500
e6a6ddc9
TR
501match_pattern_list () {
502 arg="$1"
503 shift
504 test -z "$*" && return 1
505 for pattern_
506 do
507 case "$arg" in
508 $pattern_)
509 return 0
510 esac
511 done
512 return 1
513}
514
0445e6f0
IB
515match_test_selector_list () {
516 title="$1"
517 shift
518 arg="$1"
519 shift
520 test -z "$1" && return 0
521
522 # Both commas and whitespace are accepted as separators.
523 OLDIFS=$IFS
524 IFS=' ,'
525 set -- $1
526 IFS=$OLDIFS
527
528 # If the first selector is negative we include by default.
529 include=
530 case "$1" in
531 !*) include=t ;;
532 esac
533
534 for selector
535 do
536 orig_selector=$selector
537
538 positive=t
539 case "$selector" in
540 !*)
541 positive=
542 selector=${selector##?}
543 ;;
544 esac
545
546 test -z "$selector" && continue
547
548 case "$selector" in
549 *-*)
550 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
551 then
552 echo "error: $title: invalid non-numeric in range" \
553 "start: '$orig_selector'" >&2
554 exit 1
555 fi
556 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
557 then
558 echo "error: $title: invalid non-numeric in range" \
559 "end: '$orig_selector'" >&2
560 exit 1
561 fi
562 ;;
563 *)
564 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
565 then
566 echo "error: $title: invalid non-numeric in test" \
567 "selector: '$orig_selector'" >&2
568 exit 1
569 fi
570 esac
571
572 # Short cut for "obvious" cases
573 test -z "$include" && test -z "$positive" && continue
574 test -n "$include" && test -n "$positive" && continue
575
576 case "$selector" in
577 -*)
578 if test $arg -le ${selector#-}
579 then
580 include=$positive
581 fi
582 ;;
583 *-)
584 if test $arg -ge ${selector%-}
585 then
586 include=$positive
587 fi
588 ;;
589 *-*)
590 if test ${selector%%-*} -le $arg \
591 && test $arg -le ${selector#*-}
592 then
593 include=$positive
594 fi
595 ;;
596 *)
597 if test $arg -eq $selector
598 then
599 include=$positive
600 fi
601 ;;
602 esac
603 done
604
605 test -n "$include"
606}
607
ff09af3f
TR
608maybe_teardown_verbose () {
609 test -z "$verbose_only" && return
610 exec 4>/dev/null 3>/dev/null
611 verbose=
612}
613
614last_verbose=t
615maybe_setup_verbose () {
616 test -z "$verbose_only" && return
26a07309 617 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
618 then
619 exec 4>&2 3>&1
620 # Emit a delimiting blank line when going from
621 # non-verbose to verbose. Within verbose mode the
622 # delimiter is printed by test_expect_*. The choice
623 # of the initial $last_verbose is such that before
624 # test 1, we do not print it.
625 test -z "$last_verbose" && echo >&3 ""
626 verbose=t
627 else
628 exec 4>/dev/null 3>/dev/null
629 verbose=
630 fi
631 last_verbose=$verbose
632}
633
5dfc368f
TR
634maybe_teardown_valgrind () {
635 test -z "$GIT_VALGRIND" && return
636 GIT_VALGRIND_ENABLED=
637}
638
639maybe_setup_valgrind () {
640 test -z "$GIT_VALGRIND" && return
26a07309 641 if test -z "$valgrind_only"
5dfc368f
TR
642 then
643 GIT_VALGRIND_ENABLED=t
644 return
645 fi
646 GIT_VALGRIND_ENABLED=
647 if match_pattern_list $test_count $valgrind_only
648 then
649 GIT_VALGRIND_ENABLED=t
650 fi
651}
652
9b5fe78b 653want_trace () {
f5ba2de6
JK
654 test "$trace" = t && {
655 test "$verbose" = t || test "$verbose_log" = t
656 }
9b5fe78b
JK
657}
658
a136f6d8
JK
659# This is a separate function because some tests use
660# "return" to end a test_expect_success block early
661# (and we want to make sure we run any cleanup like
662# "set +x").
663test_eval_inner_ () {
664 # Do not add anything extra (including LF) after '$*'
665 eval "
9b5fe78b 666 want_trace && set -x
a136f6d8
JK
667 $*"
668}
669
a7c58f28 670test_eval_ () {
90c8a1db
JK
671 # If "-x" tracing is in effect, then we want to avoid polluting stderr
672 # with non-test commands. But once in "set -x" mode, we cannot prevent
a136f6d8
JK
673 # the shell from printing the "set +x" to turn it off (nor the saving
674 # of $? before that). But we can make sure that the output goes to
675 # /dev/null.
676 #
90c8a1db
JK
677 # There are a few subtleties here:
678 #
679 # - we have to redirect descriptor 4 in addition to 2, to cover
680 # BASH_XTRACEFD
681 #
682 # - the actual eval has to come before the redirection block (since
683 # it needs to see descriptor 4 to set up its stderr)
684 #
685 # - likewise, any error message we print must be outside the block to
686 # access descriptor 4
687 #
688 # - checking $? has to come immediately after the eval, but it must
689 # be _inside_ the block to avoid polluting the "set -x" output
690 #
691
692 test_eval_inner_ "$@" </dev/null >&3 2>&4
a136f6d8 693 {
a136f6d8 694 test_eval_ret_=$?
9b5fe78b 695 if want_trace
a136f6d8
JK
696 then
697 set +x
a136f6d8 698 fi
90c8a1db
JK
699 } 2>/dev/null 4>&2
700
701 if test "$test_eval_ret_" != 0 && want_trace
702 then
703 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
704 fi
a136f6d8 705 return $test_eval_ret_
a7c58f28
JN
706}
707
4d9d62fa 708test_run_ () {
b6b0afdc 709 test_cleanup=:
b586744a 710 expecting_failure=$2
bb79af9d 711
92b269f5 712 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
2a01ef8c
JK
713 # turn off tracing for this test-eval, as it simply creates
714 # confusing noise in the "-x" output
715 trace_tmp=$trace
716 trace=
bb79af9d
JK
717 # 117 is magic because it is unlikely to match the exit
718 # code of other programs
878f9883
ES
719 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
720 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
99a64e4b
JH
721 then
722 error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
bb79af9d 723 fi
2a01ef8c 724 trace=$trace_tmp
bb79af9d
JK
725 fi
726
a57397b0 727 setup_malloc_check
a7c58f28 728 test_eval_ "$1"
b6b0afdc 729 eval_ret=$?
a57397b0 730 teardown_malloc_check
b586744a 731
a136f6d8
JK
732 if test -z "$immediate" || test $eval_ret = 0 ||
733 test -n "$expecting_failure" && test "$test_cleanup" != ":"
b586744a 734 then
1b3185fc 735 setup_malloc_check
a7c58f28 736 test_eval_ "$test_cleanup"
1b3185fc 737 teardown_malloc_check
b586744a 738 fi
1c0cc756
RJ
739 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
740 then
57e1538a
ÆAB
741 echo ""
742 fi
aa0bcf96 743 return "$eval_ret"
4d9d62fa
PR
744}
745
ae75342c 746test_start_ () {
8586f98b 747 test_count=$(($test_count+1))
ff09af3f 748 maybe_setup_verbose
5dfc368f 749 maybe_setup_valgrind
ae75342c
TR
750}
751
752test_finish_ () {
753 echo >&3 ""
5dfc368f 754 maybe_teardown_valgrind
ff09af3f 755 maybe_teardown_verbose
ae75342c
TR
756}
757
758test_skip () {
04ece593 759 to_skip=
ef2ac68d 760 skipped_reason=
e6a6ddc9
TR
761 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
762 then
763 to_skip=t
ef2ac68d 764 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 765 fi
05236a5e
JN
766 if test -z "$to_skip" && test -n "$test_prereq" &&
767 ! test_have_prereq "$test_prereq"
a7bb3940
JS
768 then
769 to_skip=t
ef2ac68d 770
07431fc8 771 of_prereq=
05236a5e 772 if test "$missing_prereq" != "$test_prereq"
07431fc8 773 then
05236a5e 774 of_prereq=" of $test_prereq"
07431fc8 775 fi
ef2ac68d
IB
776 skipped_reason="missing $missing_prereq${of_prereq}"
777 fi
0445e6f0
IB
778 if test -z "$to_skip" && test -n "$run_list" &&
779 ! match_test_selector_list '--run' $test_count "$run_list"
780 then
781 to_skip=t
782 skipped_reason="--run"
783 fi
07431fc8 784
ef2ac68d
IB
785 case "$to_skip" in
786 t)
633fe50a 787 say_color skip >&3 "skipping test: $@"
ef2ac68d 788 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
789 : true
790 ;;
791 *)
792 false
793 ;;
794 esac
795}
796
342e9ef2
TR
797# stub; perf-lib overrides it
798test_at_end_hook_ () {
799 :
800}
801
e1970ce4 802test_done () {
6e7b5aaf 803 GIT_EXIT_OK=t
2d84e9fb 804
1c0cc756
RJ
805 if test -z "$HARNESS_ACTIVE"
806 then
342e9ef2 807 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 808 mkdir -p "$test_results_dir"
dd78478f 809 base=${0##*/}
5c885c1b 810 test_results_path="$test_results_dir/${base%.sh}.counts"
8ef1abe5 811
5c885c1b 812 cat >"$test_results_path" <<-EOF
c54e6be7
ML
813 total $test_count
814 success $test_success
815 fixed $test_fixed
816 broken $test_broken
817 failed $test_failure
818
819 EOF
8ef1abe5 820 fi
41ac414e
JH
821
822 if test "$test_fixed" != 0
823 then
633fe50a 824 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
825 fi
826 if test "$test_broken" != 0
827 then
633fe50a 828 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
829 fi
830 if test "$test_broken" != 0 || test "$test_fixed" != 0
831 then
832 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
833 msg="remaining $test_remaining test(s)"
11d54b8b 834 else
b73d9a23 835 test_remaining=$test_count
11d54b8b 836 msg="$test_count test(s)"
41ac414e 837 fi
e1970ce4 838 case "$test_failure" in
10b94e28 839 0)
1c0cc756
RJ
840 if test $test_external_has_tap -eq 0
841 then
b73d9a23 842 if test $test_remaining -gt 0
d87bd7c1 843 then
633fe50a 844 say_color pass "# passed all $msg"
d87bd7c1 845 fi
c7018be5
JH
846
847 # Maybe print SKIP message
848 test -z "$skip_all" || skip_all="# SKIP $skip_all"
849 case "$test_count" in
850 0)
851 say "1..$test_count${skip_all:+ $skip_all}"
852 ;;
853 *)
854 test -z "$skip_all" ||
855 say_color warn "$skip_all"
856 say "1..$test_count"
857 ;;
858 esac
d998bd4a 859 fi
abc5d372 860
06478dab 861 if test -z "$debug"
4d0912a2 862 then
06478dab 863 test -d "$TRASH_DIRECTORY" ||
4d0912a2 864 error "Tests passed but trash directory already removed before test cleanup; aborting"
abc5d372 865
06478dab
JH
866 cd "$TRASH_DIRECTORY/.." &&
867 rm -fr "$TRASH_DIRECTORY" ||
4d0912a2 868 error "Tests passed but test cleanup failed; aborting"
4d0912a2 869 fi
342e9ef2
TR
870 test_at_end_hook_
871
e1970ce4
JH
872 exit 0 ;;
873
874 *)
1c0cc756
RJ
875 if test $test_external_has_tap -eq 0
876 then
633fe50a
TR
877 say_color error "# failed $test_failure among $msg"
878 say "1..$test_count"
d998bd4a 879 fi
5099b99d 880
e1970ce4
JH
881 exit 1 ;;
882
883 esac
884}
885
e4597aae 886if test -n "$valgrind"
4e1be63c 887then
4e1be63c
JS
888 make_symlink () {
889 test -h "$2" &&
890 test "$1" = "$(readlink "$2")" || {
891 # be super paranoid
892 if mkdir "$2".lock
893 then
894 rm -f "$2" &&
895 ln -s "$1" "$2" &&
896 rm -r "$2".lock
897 else
898 while test -d "$2".lock
899 do
900 say "Waiting for lock on $2."
901 sleep 1
902 done
903 fi
904 }
905 }
906
907 make_valgrind_symlink () {
36bfb0e5 908 # handle only executables, unless they are shell libraries that
11d62145 909 # need to be in the exec-path.
36bfb0e5 910 test -x "$1" ||
2a59a6ef 911 test "# " = "$(test_copy_bytes 2 <"$1")" ||
36bfb0e5 912 return;
4e1be63c
JS
913
914 base=$(basename "$1")
28fab7b2
RS
915 case "$base" in
916 test-*)
917 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
918 ;;
919 *)
920 symlink_target="$GIT_BUILD_DIR/$base"
921 ;;
922 esac
4e1be63c
JS
923 # do not override scripts
924 if test -x "$symlink_target" &&
925 test ! -d "$symlink_target" &&
2a59a6ef 926 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
4e1be63c
JS
927 then
928 symlink_target=../valgrind.sh
929 fi
efd92ffd
JS
930 case "$base" in
931 *.sh|*.perl)
932 symlink_target=../unprocessed-script
933 esac
4e1be63c
JS
934 # create the link, or replace it if it is out of date
935 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
936 }
937
26a07309
TR
938 # override all git executables in TEST_DIRECTORY/..
939 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
940 mkdir -p "$GIT_VALGRIND"/bin
503e2241 941 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
26a07309
TR
942 do
943 make_valgrind_symlink $file
944 done
945 # special-case the mergetools loadables
946 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
947 OLDIFS=$IFS
948 IFS=:
949 for path in $PATH
950 do
951 ls "$path"/git-* 2> /dev/null |
952 while read file
ad0e6233 953 do
26a07309 954 make_valgrind_symlink "$file"
ad0e6233 955 done
26a07309
TR
956 done
957 IFS=$OLDIFS
4e1be63c
JS
958 PATH=$GIT_VALGRIND/bin:$PATH
959 GIT_EXEC_PATH=$GIT_VALGRIND/bin
960 export GIT_VALGRIND
952af351
TR
961 GIT_VALGRIND_MODE="$valgrind"
962 export GIT_VALGRIND_MODE
5dfc368f 963 GIT_VALGRIND_ENABLED=t
26a07309 964 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 965 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
966elif test -n "$GIT_TEST_INSTALLED"
967then
e4597aae
MO
968 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
969 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 970 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
971 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
972else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 973 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
974 if ! test -x "$git_bin_dir/git"
975 then
976 if test -z "$with_dashes"
977 then
e4597aae
MO
978 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
979 fi
980 with_dashes=t
981 fi
982 PATH="$git_bin_dir:$PATH"
6cec5c68 983 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
984 if test -n "$with_dashes"
985 then
6cec5c68 986 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 987 fi
4e1be63c 988fi
6cec5c68 989GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 990GIT_CONFIG_NOSYSTEM=1
3c995beb 991GIT_ATTR_NOSYSTEM=1
8f323c00 992export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 993
5e87eae9
JH
994if test -z "$GIT_TEST_CMP"
995then
996 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
997 then
998 GIT_TEST_CMP="$DIFF -c"
999 else
1000 GIT_TEST_CMP="$DIFF -u"
1001 fi
1002fi
1003
20d2a30f 1004GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
6fcca938 1005export GITPERLLIB
6cec5c68 1006test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
1007 error "You haven't built things yet, have you?"
1008}
e1970ce4 1009
0e496492 1010if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool
1c0cc756 1011then
0e496492
NTND
1012 echo >&2 'You need to build test-tool:'
1013 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
56cf9806
EW
1014 exit 1
1015fi
1016
e1970ce4 1017# Test repository
002d4ce8
JK
1018TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
1019test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
1020case "$TRASH_DIRECTORY" in
1021/*) ;; # absolute path is good
1022 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 1023esac
38b074de 1024rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 1025 GIT_EXIT_OK=t
8d14ac94
JH
1026 echo >&5 "FATAL: Cannot prepare test area"
1027 exit 1
1028}
1029
90cff968 1030HOME="$TRASH_DIRECTORY"
0ea47f9d
JH
1031GNUPGHOME="$HOME/gnupg-home-not-used"
1032export HOME GNUPGHOME
90cff968 1033
1c0cc756
RJ
1034if test -z "$TEST_NO_CREATE_REPO"
1035then
38b074de 1036 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 1037else
38b074de 1038 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 1039fi
1bd9c648
LW
1040# Use -P to resolve symlinks in our working directory so that the cwd
1041# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 1042cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 1043
d5d9de1b
JS
1044this_test=${0##*/}
1045this_test=${this_test%%-*}
e6a6ddc9
TR
1046if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1047then
1048 say_color info >&3 "skipping test $this_test altogether"
1049 skip_all="skip all tests in $this_test"
1050 test_done
1051fi
f17e9fbb 1052
8648732e
BC
1053# Provide an implementation of the 'yes' utility
1054yes () {
1055 if test $# = 0
1056 then
1057 y=y
1058 else
1059 y="$*"
1060 fi
1061
6129c930
JS
1062 i=0
1063 while test $i -lt 99
8648732e 1064 do
6129c930
JS
1065 echo "$y"
1066 i=$(($i+1))
8648732e
BC
1067 done
1068}
1069
f17e9fbb 1070# Fix some commands on Windows
d98b2c5f
JS
1071uname_s=$(uname -s)
1072case $uname_s in
f17e9fbb
JS
1073*MINGW*)
1074 # Windows has its own (incompatible) sort and find
1075 sort () {
1076 /usr/bin/sort "$@"
1077 }
1078 find () {
1079 /usr/bin/find "$@"
1080 }
4114156a
JS
1081 # git sees Windows-style pwd
1082 pwd () {
1083 builtin pwd -W
1084 }
ee9fb68c 1085 # no POSIX permissions
6fd1106a 1086 # backslashes in pathspec are converted to '/'
fb9a2bea 1087 # exec does not inherit the PID
a94114ad 1088 test_set_prereq MINGW
5f4e02e5 1089 test_set_prereq NATIVE_CRLF
a31d0665 1090 test_set_prereq SED_STRIPS_CR
97669eed 1091 test_set_prereq GREP_STRIPS_CR
4d715ac0 1092 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
1093 ;;
1094*CYGWIN*)
1095 test_set_prereq POSIXPERM
a31d0665 1096 test_set_prereq EXECKEEPSPID
cfa96496 1097 test_set_prereq CYGWIN
a31d0665 1098 test_set_prereq SED_STRIPS_CR
97669eed 1099 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
1100 ;;
1101*)
1102 test_set_prereq POSIXPERM
6fd1106a 1103 test_set_prereq BSLASHPSPEC
fb9a2bea 1104 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
1105 ;;
1106esac
704a3143 1107
b082687c 1108( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 1109test -z "$NO_PERL" && test_set_prereq PERL
68c7d276 1110test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
d4e1b47a 1111test -z "$NO_PYTHON" && test_set_prereq PYTHON
94da9193 1112test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
ce9a2570
ÆAB
1113test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1114test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
5e9637c6 1115test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 1116
6cdccfce
ÆAB
1117if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1118then
1119 GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1120 unset GIT_TEST_GETTEXT_POISON_ORIG
1121fi
1122
bb946bba 1123# Can we rely on git's output in the C locale?
6cdccfce 1124if test -z "$GIT_TEST_GETTEXT_POISON"
30955229 1125then
30955229
JN
1126 test_set_prereq C_LOCALE_OUTPUT
1127fi
bb946bba 1128
4592e608
NTND
1129if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1130then
1131 GIT_TEST_CHECK_CACHE_TREE=true
1132 export GIT_TEST_CHECK_CACHE_TREE
1133fi
1134
20073274
AS
1135test_lazy_prereq PIPE '
1136 # test whether the filesystem supports FIFOs
7b7bea23
RJ
1137 test_have_prereq !MINGW,!CYGWIN &&
1138 rm -f testfifo && mkfifo testfifo
20073274
AS
1139'
1140
04083f27
JH
1141test_lazy_prereq SYMLINKS '
1142 # test whether the filesystem supports symbolic links
1143 ln -s x y && test -h y
1144'
c91cfd19 1145
b018c735
JN
1146test_lazy_prereq FILEMODE '
1147 test "$(git config --bool core.filemode)" = true
1148'
1149
ac39aa61
MG
1150test_lazy_prereq CASE_INSENSITIVE_FS '
1151 echo good >CamelCase &&
1152 echo bad >camelcase &&
1153 test "$(cat CamelCase)" != good
1154'
1155
6ec63305
WC
1156test_lazy_prereq FUNNYNAMES '
1157 test_have_prereq !MINGW &&
1158 touch -- \
1159 "FUNNYNAMES tab embedded" \
1160 "FUNNYNAMES \"quote embedded\"" \
1161 "FUNNYNAMES newline
1162embedded" 2>/dev/null &&
1163 rm -- \
1164 "FUNNYNAMES tab embedded" \
1165 "FUNNYNAMES \"quote embedded\"" \
1166 "FUNNYNAMES newline
1167embedded" 2>/dev/null
1168'
1169
5b0b5dd4
MG
1170test_lazy_prereq UTF8_NFD_TO_NFC '
1171 # check whether FS converts nfd unicode to nfc
1172 auml=$(printf "\303\244")
1173 aumlcdiar=$(printf "\141\314\210")
1174 >"$auml" &&
742ae10e 1175 test -f "$aumlcdiar"
5b0b5dd4
MG
1176'
1177
09feffb6
JK
1178test_lazy_prereq AUTOIDENT '
1179 sane_unset GIT_AUTHOR_NAME &&
1180 sane_unset GIT_AUTHOR_EMAIL &&
1181 git var GIT_AUTHOR_IDENT
1182'
1183
6219bb22
JH
1184test_lazy_prereq EXPENSIVE '
1185 test -n "$GIT_TEST_LONG"
1186'
1187
5b1fe6eb
ÆAB
1188test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1189 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1190'
1191
e1ecd9e3
JH
1192test_lazy_prereq USR_BIN_TIME '
1193 test -x /usr/bin/time
1194'
1195
1767c517
JK
1196test_lazy_prereq NOT_ROOT '
1197 uid=$(id -u) &&
1198 test "$uid" != 0
1199'
1200
63b747ce
JT
1201test_lazy_prereq JGIT '
1202 type jgit
1203'
1204
719c3da2
JH
1205# SANITY is about "can you correctly predict what the filesystem would
1206# do by only looking at the permission bits of the files and
1207# directories?" A typical example of !SANITY is running the test
1208# suite as root, where a test may expect "chmod -r file && cat file"
1209# to fail because file is supposed to be unreadable after a successful
1210# chmod. In an environment (i.e. combination of what filesystem is
1211# being used and who is running the tests) that lacks SANITY, you may
1212# be able to delete or create a file when the containing directory
1213# doesn't have write permissions, or access a file even if the
1214# containing directory doesn't have read or execute permissions.
1215
f400e51c
TB
1216test_lazy_prereq SANITY '
1217 mkdir SANETESTD.1 SANETESTD.2 &&
1218
1219 chmod +w SANETESTD.1 SANETESTD.2 &&
1220 >SANETESTD.1/x 2>SANETESTD.2/x &&
1221 chmod -w SANETESTD.1 &&
719c3da2 1222 chmod -r SANETESTD.1/x &&
f400e51c
TB
1223 chmod -rx SANETESTD.2 ||
1224 error "bug in test sript: cannot prepare SANETESTD"
1225
719c3da2 1226 ! test -r SANETESTD.1/x &&
f400e51c
TB
1227 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1228 status=$?
1229
1230 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1231 rm -rf SANETESTD.1 SANETESTD.2 ||
1232 error "bug in test sript: cannot clean SANETESTD"
1233 return $status
1234'
f838ce58 1235
d98b2c5f 1236test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
f838ce58
JK
1237GIT_UNZIP=${GIT_UNZIP:-unzip}
1238test_lazy_prereq UNZIP '
1239 "$GIT_UNZIP" -v
1240 test $? -ne 127
1241'
9a308de3
JK
1242
1243run_with_limited_cmdline () {
1244 (ulimit -s 128 && "$@")
1245}
1246
21dac1de
RJ
1247test_lazy_prereq CMDLINE_LIMIT '
1248 test_have_prereq !MINGW,!CYGWIN &&
1249 run_with_limited_cmdline true
1250'
6b9c38e1 1251
4db464f8
MG
1252run_with_limited_stack () {
1253 (ulimit -s 128 && "$@")
1254}
1255
21dac1de
RJ
1256test_lazy_prereq ULIMIT_STACK_SIZE '
1257 test_have_prereq !MINGW,!CYGWIN &&
1258 run_with_limited_stack true
1259'
4db464f8 1260
6b9c38e1
JK
1261build_option () {
1262 git version --build-options |
1263 sed -ne "s/^$1: //p"
1264}
1265
1266test_lazy_prereq LONG_IS_64BIT '
1267 test 8 -le "$(build_option sizeof-long)"
1268'
a07fb050 1269
a801a7cf
NTND
1270test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1271test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
e9184b07
JK
1272
1273test_lazy_prereq CURL '
1274 curl --version
1275'
d16ab634 1276
1277# SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1278# which will not work with other hash algorithms and tests that work but don't
1279# test anything meaningful (e.g. special values which cause short collisions).
1280test_lazy_prereq SHA1 '
1281 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1282'